package org.mandarax.util.comparators;

/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.io.Serializable;
import java.util.Comparator;
import java.util.List;

import org.mandarax.kernel.ComplexTerm;
import org.mandarax.kernel.Prerequisite;
import org.mandarax.kernel.Rule;
import org.mandarax.kernel.Term;
import org.mandarax.kernel.TermContainer;
import org.mandarax.kernel.VariableTerm;

/**
 * Abstract class for clause set comparators.
 * Implements a couple of useful count methods that can be used
 * in subclasses.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 2.2
 */
public abstract class AbstractClauseSetComparator implements Comparator,Serializable {

	/**
	 * Constructor.
	 */
	public AbstractClauseSetComparator() {
		super();
	}
	/**
	 * Count the number of negated prerequisites of a rule.
	 * @return the number of prerequisites
	 * @param rule a rule
	 */
	protected int countNegatedPrerequisites(Rule rule) {
		int count = 0;
		List body = rule.getBody();
		for (int i = 0; i < body.size(); i++) {
			Prerequisite prereq = (Prerequisite) body.get(i);
			if (prereq.isNegatedAF())
				count = count + 1;
		}
		return count;
	}
	/**
	 * Count the number of prerequisites of a rule.
	 * @return the number of prerequisites
	 * @param rule a rule
	 */
	protected int countPrerequisites(Rule rule) {

		return rule.getBody().size();
	}
	/**
	 * Count the number of variables in a term container
	 * (fact of complex term).
	 * @return the number of variables detected
	 * @param tc the term container
	 */
	protected int countVariables(TermContainer tc) {
		int count = 0;
		Term[] terms = tc.getTerms();
		for (int i = 0; i < terms.length; i++) {
			if (terms[i] instanceof VariableTerm)
				count = count + 1;
			else if (terms[i] instanceof ComplexTerm)
				count = count + countVariables((ComplexTerm) terms[i]);
		}
		return count;
	}
	/**
	 * Count the number of variables in the prerequisites of a rule.
	 * @return the number of prerequisites
	 * @param rule a rule
	 */
	protected int countVariablesInPrerequisites(Rule rule) {
		int count = 0;
		List body = rule.getBody();
		for (int i = 0; i < body.size(); i++) {
			Prerequisite prereq = (Prerequisite) body.get(i);
			count = count + countVariables(prereq);
		}
		return count;
	}
	/**
	 * Get a descriptive name.
	 * @return a string
	 */
	public abstract String getName();
	/**
	 * Convert the object to a string.
	 * @return a string
	 */
	public String toString() {
		return getName();
	}
	/**
	 * Compares objects. All instances are stateless and considered to be equal if the classes are the same!
	 * @param obj an object
	 * @return a boolean
	 */
	public boolean equals(Object obj) {
		return obj !=null && obj.getClass()==getClass();

	}
	/**
	 * Get the hash code of this object.
	 * @return an integer
	 */
	public int hashCode() {
		return getClass().hashCode();
	}
}
